var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { globalConfig, runtime } from '../providers';
let counter = 0;
export class CacheItem {
    // waitingInit: boolean;
    constructor(value, key, model) {
        // if (undefined === value) this.waitingInit = true;
        // else this.waitingInit = false;
        this.subscribe = (closFunc, config = {}) => {
            const conf = Object.assign({ immediate: true, autoUnsubscribe: true }, config);
            this.subscribers.set(++counter, closFunc);
            const id = counter;
            if (conf.immediate) {
                if (undefined !== this.value) {
                    closFunc(this.value, this.key);
                }
            }
            const unsubscribe = () => this.subscribers.delete(id);
            if (conf.autoUnsubscribe) {
                if (false !== globalConfig.autoUnsubscribe)
                    globalConfig.autoUnsubscribe(unsubscribe);
            }
            return unsubscribe;
        };
        if (undefined === value && undefined !== model.storage) {
            const test = 0;
            if ('sync' === model.options.ioType) {
                const val = model.storage.select(key);
                if (undefined !== val) {
                    value = val;
                }
            }
            else if ('async' === model.options.ioType) {
                const storage = model.storage;
                (() => __awaiter(this, void 0, void 0, function* () {
                    const val = yield storage.select(key);
                    if (undefined !== val) {
                        this.publish(val);
                    }
                }))();
            }
        }
        this.model = model;
        this.value = value;
        this.key = key;
        this.subscribers = new Map();
    }
    put(value) {
        this.value = value;
    }
    publish(value) {
        this.value = value;
        this.notifySubscribers();
    }
    get() {
        if (undefined !== runtime.readItemDependencies) {
            runtime.readItemDependencies.push(this);
        }
        if (this.model.options.name in runtime.readModelInternalItemDependencies) {
            for (const id in runtime.readModelInternalItemDependencies[this.model.options.name]) {
                runtime.readModelInternalItemDependencies[this.model.options.name][id].push(this);
            }
        }
        return this.value;
    }
    forget() {
        this.value = undefined;
    }
    notifySubscribers() {
        if (undefined === this.value)
            return;
        let value = this.value;
        let key = this.key;
        let arr = [];
        this.subscribers.forEach((job) => arr.push(job(value, key)));
        return Promise.all(arr);
    }
}
//# sourceMappingURL=cache-item.class.js.map