import { AsyncAbstractDriverInterface, SyncAbstractDriverInterface } from '../..';
import { SubscribeInterface } from '../../cache/subscribe.interface';
import { BaseModel } from '../../models/async/base-model.class';
export declare type DataKeysType<Origin extends Record<string, any>> = {
    [Key in string & keyof Origin]: Key | `${Key}$`;
}[string & keyof Origin];
export declare type DataProxyType<Origin extends Record<string, any>> = {
    [Key in DataKeysType<Origin>]: Key extends `${string}$` ? SubscribeInterface : Promise<Origin[Key]> | Origin[Key];
};
export declare class DataFactory {
    make<DataType, DriverType extends SyncAbstractDriverInterface | AsyncAbstractDriverInterface | undefined>(model: BaseModel<DataType, DriverType>): DataProxyType<DataType>;
}
