import { SyncAbstractDriverInterface, AsyncAbstractDriverInterface, KMap } from '../..';
import { BaseModel } from './base-model.class';
import { ModelOptionsInterface } from './model-options.interface';
export declare class CollectionModel<DataType = any, DriverType extends SyncAbstractDriverInterface | AsyncAbstractDriverInterface = AsyncAbstractDriverInterface> extends BaseModel<Record<string, DataType>, DriverType> {
    constructor(options: Partial<ModelOptionsInterface>);
    private nextPrimaryKey;
    seeded: boolean;
    insertItem(item: DataType): Promise<string>;
    bulkInsertItem(items: Array<DataType>): Promise<Array<string>>;
    all(): KMap<DataType>;
    seed(seed: Function | Array<DataType>): Promise<void>;
}
