import { CollectionModel as SyncCollectionModel } from './sync/collection-model.class';
import { KeyValueModel as SyncKeyValueModel } from './sync/key-value-model.class';
import { CollectionModel as AsyncCollectionModel } from './async/collection-model.class';
import { KeyValueModel as AsyncKeyValueModel } from './async/key-value-model.class';
import { AsyncAbstractDriverInterface, AsyncBaseModel, SyncAbstractDriverInterface, SyncBaseModel } from '..';
export declare const SyncModels: {
    keyValue: typeof SyncKeyValueModel;
    collection: typeof SyncCollectionModel;
};
export declare const AsyncModels: {
    keyValue: typeof AsyncKeyValueModel;
    collection: typeof AsyncCollectionModel;
};
export declare type ModelType<DataType = Record<string, any>> = SyncBaseModel<DataType, SyncAbstractDriverInterface | undefined> | AsyncBaseModel<DataType, SyncAbstractDriverInterface | AsyncAbstractDriverInterface | undefined>;
